com.orsoncharts.renderer.category

## Class LineRenderer3D

- java.lang.Object
- - com.orsoncharts.renderer.AbstractRenderer3D
  - - com.orsoncharts.renderer.category.AbstractCategoryRenderer3D
    - - com.orsoncharts.renderer.category.LineRenderer3D

- All Implemented Interfaces:
    ChartElement, CategoryRenderer3D, Renderer3D, java.io.Serializable

      public class LineRenderer3D
      extends AbstractCategoryRenderer3D
      implements java.io.Serializable

  A renderer that can be used with the `CategoryPlot3D` class to create 3D lines charts from data in a `CategoryDataset3D`. The `createLineChart()` method in the `Chart3DFactory` class will construct a chart that uses this renderer. Here is a sample:
  (refer to `LineChart3DDemo1.java` for the code to generate the above chart).
  Some attributes in the renderer are specified in "world units" - see the `Chart3D` class description for more information about world units.
  There is a factory method to create a chart using this renderer - see `Chart3DFactory.createLineChart(String, String, CategoryDataset3D, String, String, String)`.
  NOTE: This class is serializable, but the serialization format is subject to change in future releases and should not be relied upon for persisting instances of this class.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface com.orsoncharts.renderer.Renderer3D

      `TRANSPARENT_COLOR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LineRenderer3D()` Creates a new instance with default attribute values.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `composeItem(CategoryDataset3D dataset, int series, int row, int column, World world, Dimension3D dimensions, double xOffset, double yOffset, double zOffset)` Constructs and places one item from the specified dataset into the given world.
    `boolean` | `equals(java.lang.Object obj)` Tests this renderer for equality with an arbitrary object.
    `CategoryColorSource` | `getClipColorSource()` Returns the color source used to determine the color used to highlight clipping in the chart elements.
    `double` | `getIsolatedItemWidthPercent()` Returns the width for isolated data items as a percentage of the category width.
    `double` | `getLineHeight()` Returns the line height in world units.
    `double` | `getLineWidth()` Returns the line width in world units.
    `void` | `setClipColorSource(CategoryColorSource source)` Sets the color source that determines the color used to highlight clipping in the chart elements, and sends a `Renderer3DChangeEvent` to all registered listeners.
    `void` | `setIsolatedItemWidthPercent(double percent)` Sets the width for isolated data items as a percentage of the category width and sends a change event to all registered listeners.
    `void` | `setLineHeight(double height)` Sets the line height (in world units) and sends a `Renderer3DChangeEvent` to all registered listeners.
    `void` | `setLineWidth(double width)` Sets the line width (in world units) and sends a `Renderer3DChangeEvent` to all registered listeners.

    - ### Methods inherited from class com.orsoncharts.renderer.category.AbstractCategoryRenderer3D

      `findValueRange, getColorSource, getItemLabelGenerator, getItemLabelOffsets, getPlot, setColors, setColorSource, setItemLabelGenerator, setItemLabelOffsets, setPlot`

    - ### Methods inherited from class com.orsoncharts.renderer.AbstractRenderer3D

      `addChangeListener, fireChangeEvent, getItemLabelBackgroundColor, getItemLabelColor, getItemLabelFont, getItemLabelPositioning, isNotify, notifyListeners, receive, removeChangeListener, setItemLabelBackgroundColor, setItemLabelColor, setItemLabelFont, setItemLabelPositioning, setNotify`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.orsoncharts.renderer.Renderer3D

      `addChangeListener, removeChangeListener`

    - ### Methods inherited from interface com.orsoncharts.ChartElement

      `receive`

- - ### Constructor Detail

    - #### LineRenderer3D

          public LineRenderer3D()

      Creates a new instance with default attribute values.

  - ### Method Detail

    - #### getLineWidth

          public double getLineWidth()

      Returns the line width in world units. The default value is `0.4`.
      Returns:
        The line width in world units.

    - #### setLineWidth

          public void setLineWidth(double width)

      Sets the line width (in world units) and sends a `Renderer3DChangeEvent` to all registered listeners.
      Parameters:
        `width` - the width (in world units).

    - #### getLineHeight

          public double getLineHeight()

      Returns the line height in world units. The default value is `0.2`.
      Returns:
        The line height in world units.

    - #### setLineHeight

          public void setLineHeight(double height)

      Sets the line height (in world units) and sends a `Renderer3DChangeEvent` to all registered listeners.
      Parameters:
        `height` - the height (in world units).

    - #### getIsolatedItemWidthPercent

          public double getIsolatedItemWidthPercent()

      Returns the width for isolated data items as a percentage of the category width. The default value is 0.25 (twenty five percent).
      Returns:
        The width percentage.
      Since:
        1.3

    - #### setIsolatedItemWidthPercent

          public void setIsolatedItemWidthPercent(double percent)

      Sets the width for isolated data items as a percentage of the category width and sends a change event to all registered listeners.
      Parameters:
        `percent` - the new percentage.
      Since:
        1.3

    - #### getClipColorSource

          public CategoryColorSource getClipColorSource()

      Returns the color source used to determine the color used to highlight clipping in the chart elements. If the source is `null`, then the regular series color is used instead.
      Returns:
        The color source (possibly `null`).

    - #### setClipColorSource

          public void setClipColorSource(CategoryColorSource source)

      Sets the color source that determines the color used to highlight clipping in the chart elements, and sends a `Renderer3DChangeEvent` to all registered listeners.
      Parameters:
        `source` - the source (`null` permitted).

    - #### composeItem

          public void composeItem(CategoryDataset3D dataset,
                                  int series,
                                  int row,
                                  int column,
                                  World world,
                                  Dimension3D dimensions,
                                  double xOffset,
                                  double yOffset,
                                  double zOffset)

      Constructs and places one item from the specified dataset into the given world. This method will be called by the `CategoryPlot3D` class while iterating over the items in the dataset.
      Specified by:
        `composeItem` in interface `CategoryRenderer3D`
      Parameters:
        `dataset` - the dataset (`null` not permitted).
        `series` - the series index.
        `row` - the row index.
        `column` - the column index.
        `world` - the world (`null` not permitted).
        `dimensions` - the plot dimensions (`null` not permitted).
        `xOffset` - the x-offset.
        `yOffset` - the y-offset.
        `zOffset` - the z-offset.

    - #### equals

          public boolean equals(java.lang.Object obj)

      Tests this renderer for equality with an arbitrary object.
      Overrides:
        `equals` in class `AbstractCategoryRenderer3D`
      Parameters:
        `obj` - the object (`null` not permitted).
      Returns:
        A boolean.